Timer Class Reference

Timer. More...

`#include <givtimer.h>`

## Public Member Functions

void | clear ()
| Clear timer.
void | start ()
| Start timer.
void | stop ()
| Stop timer.
double | usertime () const
| total amount of second spent in user mode.
double | systime () const
| total amount of second spent in system mode.
double | realtime () const
| real total amount of second spent.
double | userElapsedTime ()
| User mode time spent since start.
double | sysElapsedTime ()
| System mode time spent since start.
double | realElapsedTime ()
| real total amount of second spent since start.

## Detailed Description

Timer.

Examples
  examples/FiniteField/gfq_atomic.C, examples/FiniteField/zpz_atomic.C, examples/Integer/Fibonacci.C, examples/Integer/ModularSquareRoot.C, examples/Integer/ProbLucas.C, examples/Integer/RSA_breaking.C, examples/Integer/RSA_decipher.C, examples/Integer/RSA_encipher.C, examples/Integer/RSA_keys_generator.C, examples/Integer/givaro-ssh-keygen.C, examples/Integer/iexponentiation.C, examples/Integer/ifactor.C, examples/Integer/ifactor_lenstra.C, examples/Integer/igcd.C, examples/Integer/igcdext.C, examples/Integer/ilcm.C, examples/Integer/ispower.C, examples/Integer/isprime.C, examples/Integer/isproot.C, examples/Integer/lambda.C, examples/Integer/lambda_inv.C, examples/Integer/nb_primes.C, examples/Integer/nextprime.C, examples/Integer/order.C, examples/Integer/phi.C, examples/Integer/prevprime.C, examples/Integer/primitiveelement.C, examples/Integer/primitiveroot.C, examples/Integer/probable_primroot.C, examples/Polynomial/PolynomialCRT.C, examples/Polynomial/highorder.C, examples/Polynomial/interpolate.C, examples/Polynomial/isirred.C, examples/Polynomial/isprimitive.C, examples/Polynomial/pol_eval.C, examples/Polynomial/pol_factor.C, and examples/Rational/iratrecon.C.

## Member Function Documentation

## clear()

void clear | ( |  | ) |

Clear timer.

Everything reset to 0. This need not be called before the first start since the constructor does it.

Examples
  examples/FiniteField/gfq_atomic.C, examples/FiniteField/zpz_atomic.C, examples/Integer/ProbLucas.C, examples/Integer/RSA_breaking.C, examples/Integer/RSA_decipher.C, examples/Integer/RSA_encipher.C, examples/Integer/RSA_keys_generator.C, examples/Integer/givaro-ssh-keygen.C, examples/Integer/iexponentiation.C, examples/Integer/ifactor.C, examples/Integer/ifactor_lenstra.C, examples/Integer/igcd.C, examples/Integer/igcdext.C, examples/Integer/ilcm.C, examples/Integer/ispower.C, examples/Integer/isprime.C, examples/Integer/isproot.C, examples/Integer/lambda.C, examples/Integer/lambda_inv.C, examples/Integer/nb_primes.C, examples/Integer/nextprime.C, examples/Integer/order.C, examples/Integer/phi.C, examples/Integer/prevprime.C, examples/Integer/primitiveelement.C, examples/Integer/primitiveroot.C, examples/Integer/probable_primroot.C, examples/Polynomial/PolynomialCRT.C, examples/Polynomial/highorder.C, examples/Polynomial/interpolate.C, examples/Polynomial/isirred.C, examples/Polynomial/isprimitive.C, examples/Polynomial/pol_eval.C, examples/Polynomial/pol_factor.C, and examples/Rational/iratrecon.C.

## start()

void start | ( |  | ) |

Start timer.

Starts the timer. If called after another `start()` or a `stop()`, it sets the timer to a totally fresh new start.

Examples
  examples/FiniteField/gfq_atomic.C, examples/FiniteField/zpz_atomic.C, examples/Integer/Fibonacci.C, examples/Integer/ModularSquareRoot.C, examples/Integer/ProbLucas.C, examples/Integer/RSA_breaking.C, examples/Integer/RSA_decipher.C, examples/Integer/RSA_encipher.C, examples/Integer/RSA_keys_generator.C, examples/Integer/givaro-ssh-keygen.C, examples/Integer/iexponentiation.C, examples/Integer/ifactor.C, examples/Integer/ifactor_lenstra.C, examples/Integer/igcd.C, examples/Integer/igcdext.C, examples/Integer/ilcm.C, examples/Integer/ispower.C, examples/Integer/isprime.C, examples/Integer/isproot.C, examples/Integer/lambda.C, examples/Integer/lambda_inv.C, examples/Integer/nb_primes.C, examples/Integer/nextprime.C, examples/Integer/order.C, examples/Integer/phi.C, examples/Integer/prevprime.C, examples/Integer/primitiveelement.C, examples/Integer/primitiveroot.C, examples/Integer/probable_primroot.C, examples/Polynomial/PolynomialCRT.C, examples/Polynomial/highorder.C, examples/Polynomial/interpolate.C, examples/Polynomial/isirred.C, examples/Polynomial/isprimitive.C, examples/Polynomial/pol_eval.C, examples/Polynomial/pol_factor.C, and examples/Rational/iratrecon.C.

## stop()

void stop | ( |  | ) |

Stop timer.

Stops the timer. The time since the previous `start()` is stored. If called again, `stop()` will store the time since the previous `start()` again, acting as a `pause()`.

Precondition
  `start()` should have been called before...

Examples
  examples/FiniteField/gfq_atomic.C, examples/FiniteField/zpz_atomic.C, examples/Integer/Fibonacci.C, examples/Integer/ModularSquareRoot.C, examples/Integer/ProbLucas.C, examples/Integer/RSA_breaking.C, examples/Integer/RSA_decipher.C, examples/Integer/RSA_encipher.C, examples/Integer/RSA_keys_generator.C, examples/Integer/givaro-ssh-keygen.C, examples/Integer/iexponentiation.C, examples/Integer/ifactor.C, examples/Integer/ifactor_lenstra.C, examples/Integer/igcd.C, examples/Integer/igcdext.C, examples/Integer/ilcm.C, examples/Integer/ispower.C, examples/Integer/isprime.C, examples/Integer/isproot.C, examples/Integer/lambda.C, examples/Integer/lambda_inv.C, examples/Integer/nb_primes.C, examples/Integer/nextprime.C, examples/Integer/order.C, examples/Integer/phi.C, examples/Integer/prevprime.C, examples/Integer/primitiveelement.C, examples/Integer/primitiveroot.C, examples/Integer/probable_primroot.C, examples/Polynomial/PolynomialCRT.C, examples/Polynomial/highorder.C, examples/Polynomial/interpolate.C, examples/Polynomial/isirred.C, examples/Polynomial/isprimitive.C, examples/Polynomial/pol_eval.C, examples/Polynomial/pol_factor.C, and examples/Rational/iratrecon.C.

## usertime()

double usertime | ( |  | ) | const

inline

total amount of second spent in user mode.

Returns
  the user time elapsed between the latest `start()` and the latest `stop()`.

Precondition
  `stop()` is called before.

Examples
  examples/FiniteField/gfq_atomic.C, examples/FiniteField/zpz_atomic.C, and examples/Polynomial/pol_factor.C.

## systime()

double systime | ( |  | ) | const

inline

total amount of second spent in system mode.

Returns
  the system time elapsed between the latest `start()` and the latest `stop()`.

Precondition
  `stop()` is called before.

## realtime()

double realtime | ( |  | ) | const

inline

real total amount of second spent.

Returns
  the real total time elapsed between the latest `start()` and the latest `stop()`.

Precondition
  `stop()` is called before.

## userElapsedTime()

double userElapsedTime | ( |  | ) |

inline

User mode time spent since start.

A call to `stop()` is useless.

Returns
  elpased time (in seconds) since `start()` in user mode.

## sysElapsedTime()

double sysElapsedTime | ( |  | ) |

inline

System mode time spent since start.

A call to `stop()` is useless.

Returns
  elpased time (in seconds) since `start()` in system mode.

## realElapsedTime()

double realElapsedTime | ( |  | ) |

inline

real total amount of second spent since start.

A call to `stop()` is useless.

Returns
  elpased time (in seconds) since `start()`.

The documentation for this class was generated from the following files:

- givtimer.h
- givtimer.C